package pot;

import java.io.*;
import java.net.*;
import pot.util.*;
import pot.serverskeleton.*;
//import pot.user.*;
import pot.intp.*;
import pot.docs.*;
import pot.dist.*;
import pot.phys.*;

public class Init extends GrandParentServer
{
    SocketParentServer intp, docs, dist, phys;
    // argsǻǤ褦ˤ٤
    final String potRootPath = "/home/users/itogawa/research/potroot";

    public void init()
	throws ConstructionFailureException, IOException
    {
        intp = new InterpretationParentServer(potRootPath+"/conf/intp");
        docs = new DocumentParentServer(potRootPath+"/conf/docs");
        dist = new POTFileParentServer(potRootPath+"/conf/dist");
        phys = new StorageParentServer(potRootPath+"/conf/phys");
    }

    public void go()
    {
    }

    public void stop()
    {
        phys.stopThread();
        dist.stopThread();
        docs.stopThread();
        intp.stopThread();
    }

    public void quit()
    {
        phys.destroy();
        dist.destroy();
        docs.destroy();
        intp.destroy();
        System.exit(0);
    }

    public static void main(String[] args)
	throws ConstructionFailureException, IOException
    {
        System.out.println(pot.util.Util.getShortHostName());
        Init i = new Init(); 
    }
}

