package pot.dist;

import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import pot.util.*;
import pot.serverskeleton.*;

/**  ʬؤοƥС */
public class POTFileParentServer extends SocketParentServer
{
    Hashtable hostChecker;
    Vector friendHostNames;

    /** 󥹥ȥ饯 */
    public POTFileParentServer(String confPath)
	throws ConstructionFailureException
    {
	super(confPath);
	friendHostNames = (Vector)getProperty("FriendHostNames");
    }
    
    public GenericChildServer newChild(Socket ss) throws Exception
    {
        return new POTFileChildServer
	    (this, ss, "localhost",
	     new Integer((String)getProperty("RemotePortNumber")));
    }

    protected void setTimeout(Socket s)
    {
	try{
	s.setSoTimeout(30*1000);
	}catch(SocketException e){}
    }

    protected boolean verifyRemoteHost(Socket socket)
    {
	String hn = socket.getInetAddress().getHostName();
	return  (hn.equals("localhost") || friendHostNames.contains(hn));
    }


    ObjectBasedClient newOBC()
	 throws IOException, ClassNotFoundException
    {
        ObjectBasedClient obc = new ObjectBasedClient
            (this, "localhost",
             Integer.parseInt((String)getProperty("RemotePortNumber")));
        obc.openObjectStream();
        return obc;
    }

    public void deleteOBC(ObjectBasedClient obc) throws DisconnectionException
    {
        obc.disconnect();
        obc = null;
    }

    TextBasedClient newTBC(String hostname)
	 throws IOException, ClassNotFoundException
    {
        TextBasedClient tbc = new TextBasedClient
            (this, hostname,
             Integer.parseInt((String)getProperty("ListeningPortNumber")));
        tbc.openStream();
        return tbc;
    }

    public void deleteTBC(TextBasedClient tbc) throws DisconnectionException
    {
        tbc.disconnect();
        tbc = null;
    }

    public synchronized TXDocument retrieve(String fromHost, String path)
	throws ClassNotFoundException, IOException, DisconnectionException
    {
	ObjectBasedClient obc = newOBC();
	obc.putObject("get "+path);
	TXDocument d = (TXDocument)obc.getObject();
	obc.getObject(); //"bye"ξò
	deleteOBC(obc);
	return d;
    }
    
    public synchronized TXDocument ls(String fromHost, String path)
	throws ClassNotFoundException, IOException, DisconnectionException
    {
	ObjectBasedClient obc = newOBC();
	obc.putObject("ls "+path);
	TXDocument d = (TXDocument)obc.getObject();
	obc.getObject(); //"bye"ξò
	deleteOBC(obc);
	return d;
    }

    public synchronized Boolean exists(String fromHost, String path)
	throws ClassNotFoundException, IOException, DisconnectionException
    {
	ObjectBasedClient obc = newOBC();
	obc.putObject("exists "+path);
	Boolean b = (Boolean)obc.getObject();
	obc.getObject(); //"bye"ξò
	deleteOBC(obc);
	return b;
    }

    public synchronized String store(String fromHost, String path, 
				     TXDocument d)
	throws ClassNotFoundException, IOException, DisconnectionException
    {
	String status="";
	ObjectBasedClient obc = newOBC();
	obc.putObject("put "+path);
	if (((String)obc.getObject()).equals("ack"))
	{
	    obc.putObject((Object)d);
	    status = (String)obc.getObject();
	}
	deleteOBC(obc);
	return status;
    }

    public synchronized String copy(String remoteHost, String fromHost, 
				    String toHost, String path)
	throws ClassNotFoundException, IOException, DisconnectionException
    {
	return "not implemented yet.";
    }
}

