package pot.docs;

import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import pot.util.*;
import pot.serverskeleton.*;

/**
  ʸؤοƥС
 */
public class DocumentParentServer extends SocketParentServer
{
    /**
      󥹥ȥ饯
     */
    public DocumentParentServer(String confPath)
	throws ConstructionFailureException
    {
	super(confPath);
    }
    
    protected boolean verifyRemoteHost(Socket socket)
    {
	//System.err.println("@"+socket.getInetAddress().getHostName());
	return (socket.getInetAddress().equals(socket.getLocalAddress()));
    }

    public GenericChildServer newChild(Socket ss) throws Exception
    {
        return new DocumentChildServer
	    (this, ss, (String)getProperty("RemoteHostName"),
	     new Integer((String)getProperty("RemotePortNumber")));
    }

    public TextBasedClient newTBC() throws IOException
    {
	TextBasedClient tbc = 
	    new TextBasedClient(this, (String)getProperty("RemoteHostName"),
		Integer.parseInt((String)getProperty("RemotePortNumber")));
        tbc.openStream();
	return tbc;
    }

    public void deleteTBC(TextBasedClient tbc) throws DisconnectionException
    {
        tbc.disconnect();
        tbc = null;
    }

    public synchronized void Upload
	(TextBasedClient tbc, Object o) throws IOException
    {
	if (o.getClass() == String.class)
	    tbc.putLine((String)o);
	else if (o.getClass() == TXDocument.class)
	{
	    ((TXDocument)o).printWithFormat(tbc.getWriter());
	    tbc.putLine("*");
	}
	else throw new IOException();
    }

    public synchronized Object getXMLDocument(TextBasedClient tbc)
	throws IOException, ClassNotFoundException
    {
	CatalogParser p = new CatalogParser
             ("stdin", (String)getProperty("URLCatalogPath"));
	Reader r = tbc.getReader();
	TXDocument result = p.readStream(r);
	return result;
    }

    /**
      ꤷidTXDocument롣
     */
    public TXDocument retrieve(String id)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	TXDocument result;
	TextBasedClient tbc = newTBC();
	Upload(tbc, "get "+id);
	result = (TXDocument)getXMLDocument(tbc);
	deleteTBC(tbc);
	return result;
    }

    public TXDocument ls(String id)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	TXDocument result;
	TextBasedClient tbc = newTBC();
	Upload(tbc, "ls "+id);
	result = (TXDocument)getXMLDocument(tbc);
	deleteTBC(tbc);
	return result;
    }

   /** ꤷʸ¸ߤĴ٤롣 */
    public Boolean exists(String id)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	Boolean result;
	TextBasedClient tbc = newTBC();
	Upload(tbc, "exists "+id);
	result = new Boolean(tbc.getLine());
	deleteTBC(tbc);
	return result;
    }

    /** ꤷʸֺפ롣 */
    public String delete(String id)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	POTDocument p = new POTDocument(retrieve(id));
	p.delete();
	return store(p.getTXDocument());
    }

    /** ؤϤ줿ʸùʬؤ롣*/
    public String store(TXDocument d)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String status = "";
	TextBasedClient tbc = newTBC();
	String id = d.getDocumentElement().getAttribute("id");
	String type = null;

	if (exists(id).booleanValue())
	{
	  POTDocument nd = new POTDocument(d);
	  TXDocument od = retrieve(id);
	  nd.update(od);
	  d = nd.getTXDocument();
	  nd = null;
	}
	else
	{
	  POTDocument pd = new POTDocument(d);
	  pd.newLog();
	  d = pd.getTXDocument();
	}
	Upload(tbc, "put "+id);
	Upload(tbc, d);
	status = tbc.getLine();
	deleteTBC(tbc);
	return status;
    }

}

