package pot.docs;

import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import pot.util.*;
import pot.serverskeleton.*;

/** 
  POTʸ륯饹
 */
public class POTDocument
{
    protected TXDocument txd;

    /** 󥹥ȥ饯 */
    public POTDocument(TXDocument _txd) throws IOException
    {
	txd = _txd;
	//if (getRoot() == null)
	//    throw new IOException();
	//if (!getRoot().getTagName().equals("doc"))
	//    throw new IOException();
    }

    /** ˸ƤФ롣 */
    public void newLog() throws IOException
    {
	TXElement root = getRoot();
	TXElement result = (TXElement)getLinks().clone();
	
	result.setTagName("logs");
	TXElement[] items = result.searchChildrenAll("link");
	for(int i=0; i<items.length; i++)
	{
	    items[i].setTagName("logitem");
	    stampTime(items[i]);
	}
	
	result.insertFirst(newLogItem("create"));

	getRoot().insertFirst(result);
    }

    /** 2ܰʹߤϿ˸ƤФ롣*/
     public void update(TXDocument od)
     {
	 getRoot().replaceChild(((TXElement)od.getDocumentElement()).
				getElementNamed("logs"), getLogs());
	 updateLogs(od, "auth");
	 updateLogs(od, "ctrl");
	 updateLogs(od, "text");
     }

    /** ꤵ줿̤Υ󥯤֤ */
    public TXElement getLink(String type)
    {
	TXElement result = null;
	String ltype, lid;
	TXElement[] ls = getLinks().searchChildrenAll("link");
	if (ls.length == 0)
	  {
	    return pot.util.Util.preparedTXElement("link");
	  }
	
	for(int i=0; i<ls.length; i++)
	{
	    lid = ls[i].getAttribute("id");
	    if (pot.util.Util.getTypeName(lid).equals(type))
		result = ls[i];
	}
	return result;
    }

    /** ꤵ줿̤Υ󥯤ID֤ */
    protected String getLinkID(TXDocument d, String type)
    {
	String result = "";
	String ltype, lid;
	TXElement[] ls = ((TXElement)d.getDocumentElement()).
	    getElementNamed("links").searchChildrenAll("link");
	if (ls.length == 0)
	  {
	    return "forbidden";
	  }
	
	for(int i=0; i<ls.length; i++)
	{
	    lid = ls[i].getAttribute("id");
	    ltype = pot.util.Util.getTypeName(lid);
	    if (ltype.equals(type))
		result = lid;
	}
	return result;
    }

    /** ꤵ줿̤Υ󥯤IDν֤ */
    protected String[] getLinkIDs(TXDocument d, String type)
    {
	Vector v = new Vector();
	String ltype, lid;
	TXElement[] ls = ((TXElement)d.getDocumentElement()).
	    getElementNamed("links").searchChildrenAll("link");
	for(int i=0; i<ls.length; i++)
	{
	    lid = ls[i].getAttribute("id");
	    ltype = pot.util.Util.getTypeName(lid);
	    if (ltype.equals(type))
		v.addElement(lid);
	}
	//ФäȸΨΤˡꤽ^^;;
	String[] result = new String[v.size()];
	for(int i=0; i<v.size(); i++)
	{
	    result[i] = (String)v.elementAt(i);
	}
	return result;
    }

    /** 󥯤ѹϿ롣*/
    void updateLogs(TXDocument newDoc, String type)
    {
	if (type.equals("text"))
	{
	    if (!getTextValue().equals(getTextValue(newDoc)))
	      {
		TXElement litem = (TXElement)getText(newDoc).clone();
		TXElement pwd = null;
		//ǤΤȿ§ʤΤġġ
		if ((pwd = litem.getElementNamed("passwd")) != null)
		    litem.removeChild(pwd);
		litem.setTagName("logitem");
		litem.setAttribute("id", "text");
		try{stampTime(litem);
		}catch(DOMException e){}
		getLogs().appendChild(litem);
	      }
	}
	else
	{
	    String olid = getLinkID(txd, type);
	    String nlid = getLinkID(newDoc, type);
	    if (!nlid.equals(olid))
	      getLogs().appendChild(newLogItem(getLinkID(txd, type)));
	}
    }

    /** ꤵ줿̤Υ󥯤IDѹ */
    public void setLinkID(String type, String newID)
    {
	String ltype, lid;
	TXElement[] ls = getLinks().searchChildrenAll("link");

	for(int i=0; i<ls.length; i++)
	{
	    lid = ls[i].getAttribute("id");
	    ltype = pot.util.Util.getTypeName(lid);
	    if (ltype.equals(type))
		ls[i].setAttribute("id", newID);
	}
    }

    /** logs˿ܤä */
    TXElement newLogItem(String id)
    {
	TXElement litem = (TXElement)txd.createElement("logitem");
	litem.setAttribute("id", id);
	stampTime(litem);
	return litem;
    }

    /** TXElement˻򵭤*/
    void stampTime(TXElement e)
    {
	e.setAttribute("date", (new ISODate()).toString());
    }

    /** ʸΡֺפԤ */
    public void delete()
    {
	TXElement r = getRoot();
	r.replaceChild(pot.util.Util.preparedTXElement
		       ("text", "deleted"), getText());
	r.replaceChild(pot.util.Util.preparedTXElement
		       ("links", "deleted"), getLinks());
	r.setAttribute("status", "deleted");
	getLogs().appendChild(newLogItem("delete")); //
    }

    /** ꤵ줿̤Υܤ֤ */
    protected TXElement getLogID(String type)
    {
	TXElement result = null;
	String lid;
	TXElement[] ls = getLogs().searchChildrenAll("logitem");
	for(int i=0; i<ls.length; i++)
	{
	    lid = ls[i].getAttribute("id");
	    if (lid.equals(type))
		result = ls[i];
	}
	return result;
    }

    /** TXDocument֤ */
    public TXDocument getTXDocument()
    {
	return txd;
    }	

    /** root element֤ */
    public TXElement getRoot(TXDocument d)
    {
	return (TXElement)d.getDocumentElement();
    }	

    /** root element֤ */
    public TXElement getRoot()
    {
	return getRoot(txd);
    }	

    /** Textʬ֤ */
    public TXElement getText(TXDocument d)
    {
	return getRoot(d).getElementNamed("text");
    }

    /** Textʬ֤ */
    public TXElement getText()
    {
	return getText(txd);
    }

    /** Textʬʸ֤ */
    public String getTextValue(TXDocument d)
    {
	return getText(d).getText(); //ޤ路^^;
    }

    /** Textʬʸ֤ */
    public String getTextValue()
    {
	return getTextValue(txd);
    }

    /** Logsʬ֤ */
    public TXElement getLogs(TXDocument d)
    {
	return getRoot(d).getElementNamed("logs");
    }

    /** Logsʬ֤ */
    public TXElement getLogs()
    {
	return getLogs(txd);
    }

    /** Linksʬ֤ */
    public TXElement getLinks(TXDocument d)
    {
	return getRoot(d).getElementNamed("links");
    }

    /** Linksʬ֤ */
    public TXElement getLinks()
    {
	return getLinks(txd);
    }

    /** ʸID֤ */
    public String getID()
    {
	return getRoot().getAttribute("id");
    }

    /** ʸμ̤֤ */
    public String getDocType()
    {
	TXAttribute a;
	TXElement r = getRoot();
	if (r != null)
	    a = (TXAttribute)r.getAttributeNode("id");
	else 
	    return null;
	if (a != null)
	    return pot.util.Util.getTypeName(a.getValue());
	else 
	    return null;
    }

    /** ٤֤ */
    public int getImportance()
    {
	return 0;//dummy
	//return Integer.parseInt(getRoot().getAttribute("importance"));
    }

    /** ʸ񤬡ֺפ줿ݤ֤ */
    public boolean isDeleted()
    {
        TXElement r = getRoot();
	if (r != null)
	  return (r.getAttribute("status").equals("deleted"));
	else 
	  return false;
    }

    /** ISODate֤*/
    public String getCreationDate()
    {
	return getLogID("create").getAttribute("date");
    }
}

