package pot.intp;

import pot.docs.*;
import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import pot.util.*;
import pot.serverskeleton.*;

/**
  ʸ
 */
public class CtrlDocument extends OrdinaryDocument
{
    /** Constructor. */
    public CtrlDocument(TXDocument _txd)
	 throws IOException
    {
	super(_txd);
    }

    public String permissionParts(String userID, String owner, String creation)
    {
      ISODate date = new ISODate();
      TXElement r = getRoot().getElementNamed("text");
      TXElement times[] = r.searchChildrenAll("time");
      TXElement time = null;
      ISODate epoch;
      for(int i=times.length-1; i>=0; i--)
	{
	    String timeval = times[i].getAttribute("value");
	    if (timeval.startsWith("A") || timeval.startsWith("B"))
	    {
		epoch = new ISODate(creation);
		epoch.addOffset(timeval);
	    }
	    else
		epoch = new ISODate(timeval);
	    if(epoch.earlierThan(date))
		{
		    time = times[i];
		    break;
		}
	}

      if (time == null) return "all"; //§ȤƤŤ᤹

      TXElement ranges[] = time.searchChildrenAll("range");
      String result = "all";
      for(int i=0; i<ranges.length; i++)
	  {
	      String ra = ranges[i].getAttribute("value");
	      if((ra.equals("owner") && owner.equals(userID))
		 || userID.startsWith(ra))
	       result = ranges[i].getText();
	  }
      return result;
    }
  
    public boolean permission(String userID, String part, 
			      String owner, String creation)
    {
	StringTokenizer p = new StringTokenizer
	    (permissionParts(userID, owner, creation), ",");
	String s;
	while(p.hasMoreTokens())
	{
	    s = p.nextToken();
	    if(s.equals(part))
		return true;
	}
	return false;
    }
   
    public TXDocument filter(String uid, OrdinaryDocument d)
    {
	TXElement r = d.getRoot();
	String owner = d.getAuthID();
	owner = owner.substring(5, owner.length());

	//ʸownerˤϾƤ
	if (owner.equals(uid)|| getID().equals("ctrl:root:permanent"))
	  {
	    return d.getTXDocument();
	  }
	else if (!d.getID().equals("auth:"+uid))
	{
	    TXElement ps = d.getText().getElementNamed("passwd");
	    if (ps != null){d.getText().removeChild(ps);}
	}
	String creation = d.getCreationDate();
	if (permission(uid, "all", owner, creation))
	    return d.getTXDocument();
	else if (permission(uid, "meta", owner, creation))
		r.replaceChild(pot.util.Util.preparedTXElement
			       ("text", "forbidden"),d.getText());
	return d.getTXDocument();
    }
}

