package pot.intp;

import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import pot.util.*;
import pot.serverskeleton.*;

/**
  ؤλҥС
  */
public class InterpretationChildServer extends T2XPipe
{
    /** ΥФưѼԤID롣 */
    String userID;
    InterpretationParentServer pt;
    
    /**
      󥹥ȥ饯
      */
    public InterpretationChildServer(GenericParentServer gps, Socket s,
				     String _hostName, Integer _portNumber)
	throws IOException
	{
	    super(gps, s, _hostName, _portNumber);
	    pt = (InterpretationParentServer) parent;
	    setPrompt("POT> ");
	    InterpretationParentServer pt = 
	      (InterpretationParentServer) parent;
	}
    
    public TXElement getTextElement() throws IOException
    {
	String text = "", line;
	TXDocument factory = pot.util.Util.preparedTXDocument("dummy");
	TXElement result = (TXElement)factory.createElement("text");
	while(!(line = getLine()).equals("."))
	    text += (line+"\n");
	result.appendChild(factory.createTextNode(text));
	return result;
    }

    public TXElement getXMLElement() throws IOException
    {
	String text = "", line;
	while(!(line = getLine()).equals("."))
	    text += (line+"\n");
	pot.util.CatalogParser p = new pot.util.CatalogParser
             ("intpch", (String)parent.getProperty("URLCatalogPath"));
	return (TXElement)p.readStream(new StringReader(text)).
	  getDocumentElement();
    }

    /** ޥɤؤα  */
    public void handle(String command)
	throws IOException,  DisconnectionException
    {
	String line;
	StringTokenizer st = new StringTokenizer(command, " \t");
	try
	{
	    if (st.hasMoreTokens())
	    {
		command = st.nextToken();
		if (command.equals("help"))
		{
		    putLine("help");
		    putLine("whoami");

		    putLine("store type docIDPart ctrlID specIDs");
		    putLine("storeauth docIDPart ctrlID");

		    putLine("exists docID");
		    putLine("get docID");
		    putLine("gettext docID");
		    putLine("ls path");

		    putLine("chtext docID");
		    putLine("chctrl docID ctrlID");
		    putLine("chown userID docID (limit)");
		    putLine("getown docID");
		    putLine("denyown docID");

		    putLine("delete docID");
		    putLine("rmauth userID docID (limit)");
		    putLine("getrmauth docID");
		    putLine("denyrmauth docID");

		    putLine(".");
		}		
		else if (command.equals("whoami"))
		{
		    putLine("! "+userID);
		}		
		//if (command.equals("retrieve") && st.hasMoreTokens())
		else if (command.equals("get") && st.hasMoreTokens())
		{
		    String docID = st.nextToken();
		    if (pt.exists(docID).booleanValue())
			{
			    putXMLFile(pt.retrieve(userID, docID));
			    putLine(".");
			}
		    else
			putLine("! No such document or defunct document "
				+"named "+docID+".");
		}
		else if (command.equals("gettext") && st.hasMoreTokens())
		//else if (command.equals("retrievetext")&&st.hasMoreTokens())
		{
		    String docID = st.nextToken();
		    if (pt.exists(docID).booleanValue())
		    {
			OrdinaryDocument d = 
			    new OrdinaryDocument(pt.retrieve(userID, docID));
			putLine(d.getTextValue());
			putLine(".");
		    }
		    else
			putLine("! No such document or defunct document "
				+"named "+docID+".");
		}
		else if (command.equals("ls") && st.hasMoreTokens())
		{
		    String docID = st.nextToken();
		    TXDocument t = pt.ls(userID, docID);
		    if (t.getDocumentElement() != null)
			{
			    putXMLFile(t);
			    putLine(".");
			}
		    else
			putLine("! No such directory named "+docID+".");
		}
		else if (command.equals("exists") && st.hasMoreTokens())
		{
		    putLine("! "+pt.exists(st.nextToken()).toString());
		}		
		else if (command.equals("delete") && st.hasMoreTokens())
		{
		    putLine("! "+pt.delete(userID, st.nextToken()));
		}		
		else if (command.equals("store") && st.hasMoreTokens())
		{
		    String docType = st.nextToken();
		    if (docType.equals(""))
		      putLine("! use storeauth.");
		    else if ((docType.equals("ordn"))||
			     (docType.equals("spec"))||		      
			     (docType.equals("ctrl")))
		    {
		      String docID = docType+":"+userID+":"+st.nextToken();
		      String ctrlID = st.nextToken();	
		      String specIDs = "spec:root:ctrlspec";
		      TXElement t;
		      if (!(docType.equals("ctrl")))
		      {
			specIDs = st.nextToken();
		        t =getTextElement();
		      }
		      else
		        t =getXMLElement();
		      String idType = pot.util.Util.getTypeName(docID);
		      if (pt.exists(docID).booleanValue())
			putLine("! already exists.");
		      else
			putLine("! "+pt.store(userID, docID, ctrlID,
			      pot.util.Util.splitIDs(specIDs), t));
		      }
		    else
		      putLine("! wrong doctype.");
		}
		else if (command.equals("storeauth") && st.countTokens() == 2)
		{
		    String docID = "auth:"+userID+":"+st.nextToken();
		    String ctrlID = st.nextToken();	
		    String[] specIDs = {"spec:root:authspec"};
		    //passwdƤޤġ
		    putString("password:");
		    TXElement t = pot.util.Util.preparedTXElement("text");
		    TXElement p = 
			pot.util.Util.preparedTXElement("passwd", getLine());
		    t.appendChild(p);
		    TXElement a = pot.util.Util.preparedTXElement
		      ("announce");
		    a.appendChild(pot.util.Util.preparedTXElement
				  ("message", "Hajimemashite!"));
		    t.appendChild(a);
		    putLine("! "+pt.store(userID, docID, ctrlID, specIDs, t));
		}
		else if (command.equals("chtext") && st.countTokens() == 1)
		{
		    String docID = st.nextToken();
		    String idType = pot.util.Util.getTypeName(docID);
		    if(idType.equals("auth")||idType.equals("ctrl"))
		    {
			TXElement t =getXMLElement();
			if (idType.equals("auth"))
			    {
				TXElement a = pot.util.Util.
				    preparedTXElement("announce");
				a.appendChild(pot.util.Util.preparedTXElement
					      ("message", ""));
				t.appendChild(a);
			    }
			putLine("! "+pt.chtext(userID, docID, t));
		    }
		    else
			putLine("! can't replace the text.");
		}
		else if (command.equals("chctrl") && st.countTokens() == 2)
		{
		    String docID = st.nextToken();
		    String ctrlID = st.nextToken();
		    String idType = pot.util.Util.getTypeName(docID);
		    putLine("! "+pt.chctrl(userID, docID, ctrlID));
		}
		else if (command.equals("chown") && st.countTokens() >= 2)
		{
		    String newOwner = st.nextToken();
		    String docID = st.nextToken();
		    String limit = "";
		    if (st.hasMoreTokens())
			limit = st.nextToken();
		    putLine("! "+pt.chown(userID, newOwner, docID, limit));
		}
		else if (command.equals("getown") && st.countTokens() == 1)
		{
		    putLine("! "+pt.getown(userID, st.nextToken())); //docID
		}
		else if (command.equals("denyown") && st.countTokens() == 1)
		{
		    putLine("! "+pt.denyown(userID, st.nextToken()));
		}		
		else if (command.equals("rmauth") && st.countTokens() >= 1)
		{
		    String victim = st.nextToken();
		    String limit = "";
		    if (st.hasMoreTokens())
			limit = st.nextToken();
		    putLine("! "+pt.rmauth(userID, victim, limit));
		}
		else if (command.equals("getrmauth"))
		{
		    putLine("! "+pt.getrmauth(userID));
		}
		else if (command.equals("denyrmauth"))
		{
		    putLine("! "+pt.denyrmauth(userID));
		}		
		else if (command.equals("doagent") && st.countTokens() == 1)
		{
		    if (pt.verifyLocalRoot(userID))
		    {
			pt.doAgent(userID, st.nextToken());
			putLine("! OK");
		    }
		    else
			putLine("! operation not permitted.");
		}		
		else if (!command.equals("bye"))
		{
		    putLine("! Unknown Command.");
		}
		else disconnect();
	    }
	}catch(ClassNotFoundException e){
	    throw new IOException();
	}
    }
    
    public void run()
    {
        try{
            openStream();

	    putString("login: ");
	    String _userID = getLine();
	    putString("password: ");
	    String passwd = getLine();
	    if (pt.verifyLogin(_userID, passwd))
	    {
		userID = _userID;
		putLine("Welcome, "+userID+".");
		putLine(pt.showAnnounce(userID));
		putLine(".");
	    }
	    else
	    {
		putLine("Login Failed.");
		disconnect();
	    }

            while(true)
            {
                putPrompt();
                handle(getLine());
            }
        }catch(IOException e){
            printLog(e);
        }catch(DisconnectionException e){
            printLog(e);
        }catch(ClassNotFoundException e){
            printLog(e);
        }
    }
}

