package pot.intp;

import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import pot.util.*;
import pot.serverskeleton.*;

/**
  ؤοƥС
 */
public class InterpretationParentServer extends SocketParentServer
{
    /** ʸؤФʸΥå塣 */
    CacheTable docsCache;
    String localRootID;
    String daemonID;
    Agent ag;
  
    /**
      󥹥ȥ饯
     */
    public InterpretationParentServer(String confPath)
	throws IOException, ConstructionFailureException
    {
	super(confPath);
	docsCache = new CacheTable(128);
	localRootID = (String)getProperty("LocalRoot");
	daemonID = "root";
	ag = new Agent(this, daemonID);
    }
    
    /** ҥФ롣*/
    public GenericChildServer newChild(Socket ss) throws Exception
    {
        return new InterpretationChildServer
	    (this, ss, (String)getProperty("RemoteHostName"),
	     new Integer((String)getProperty("RemotePortNumber")));
    }

    /** ʸؤ˥륯饤Ȥ롣*/
    ObjectBasedClient newOBC() throws IOException, ClassNotFoundException
    {
	ObjectBasedClient obc = new ObjectBasedClient
	    (this, (String)getProperty("RemoteHostName"),
	     Integer.parseInt((String)getProperty("RemotePortNumber")));
        obc.openObjectStream();
	return obc;
    }

    /** ʸؤ˥륯饤Ȥ˴롣*/
    void deleteOBC(ObjectBasedClient obc) throws DisconnectionException
    {
        obc.disconnect();
	obc = null;
    }

    /** ʸϿ*/
    public synchronized String store(String userID, String docID,
		String ctrlID, String[] specID, TXElement text)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String status;
	String[] links = POTDocumentFragment.makeLinks(userID, ctrlID, specID);
	if (links == null) return "Invalid link(s).";
	for(int i=0; i<links.length; i++)
	{
	    System.err.println(links[i]);
	    if (!exists(links[i]).booleanValue())
	      {
		if (docsCache.containsKey(docID))
		  docsCache.remove(docID);
		return "Invalid link(s): "+links[i];
	      }
	}
	TXDocument d = new POTDocumentFragment(docID, links, text).
	  getTXDocument();
	return forcedStore(docID, d);
    }
    
    public synchronized void correctLinks(String docID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
      TXDocument d = forcedRetrieve(docID);
      OrdinaryDocument o = new OrdinaryDocument(d);
      OrdinaryDocument m;
      m = new OrdinaryDocument(forcedRetrieve(o.getCtrlID()));
      if (m.isDeleted())
	  o.setLinkID("ctrl", "ctrl:root:permanent");
      m = new OrdinaryDocument(forcedRetrieve(o.getAuthID()));
      if (m.isDeleted())
	  o.setLinkID("auth", "auth:root");
      forcedStore(docID, d);
    }
  
    public synchronized void doAgent(String userID, String cmd)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	if (userID.equals(daemonID) || userID.equals("root"))
	{
	    ag.recursiveDo("ordn", cmd);
	    ag.recursiveDo("auth", cmd);
	    ag.recursiveDo("ctrl", cmd);
	    ag.recursiveDo("spec", cmd);
	}
    }

    public synchronized String forcedStore(String docID, TXDocument d)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
        String status = "";
        ObjectBasedClient obc = newOBC();
	obc.putObject("put "+docID);
	if (((String)obc.getObject()).equals("ack"))
	{
	    obc.putObject((Object)d);
	    if (docsCache.containsKey(docID))
		docsCache.remove(docID);
	}
	status = (String)obc.getObject();
	deleteOBC(obc);
	return status;
    }

    public synchronized TXDocument ls(String userID, String path)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	TXDocument result = null;
	ObjectBasedClient obc = newOBC();
	obc.putObject("ls "+path);
	result = (TXDocument)obc.getObject();
	deleteOBC(obc);
	return result;
    }

    /** ʸfilterʸμФ */
    public TXDocument retrieve(String userID, String docID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	OrdinaryDocument result = 
	    new OrdinaryDocument(forcedRetrieve(docID)); 
	if (result.isDeleted())
	  return result.getTXDocument();
	  //return pot.util.Util.nullTXDocument();
	String ctrlID = result.getCtrlID();
	if (ctrlID.equals("forbidden"))
	  return result.getTXDocument();
	if (result.getID().equals("ctrl:root:permanent"))
	  return result.getTXDocument();
	else
	{
	  CtrlDocument ctrl = new CtrlDocument(retrieve(userID, ctrlID));
	  return ctrl.filter(userID, result);
	}
	  
    }
    
    /** ʸ̵ʼФ */
    public TXDocument forcedRetrieve(String docID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	ObjectBasedClient obc;
	TXDocument result = (TXDocument)docsCache.get(docID);
	if (result == null)
        {
	    obc = newOBC();
	    obc.putObject("get "+docID);
	    result = (TXDocument)obc.getObject();
	    deleteOBC(obc);
	    if (result.getDocumentElement() != null)
	      docsCache.put(docID, result.clone());
	}
	else result = (TXDocument)result.clone();

	return result;
    }    

    /** ʸκ(ºݤˤϽ񤭴) */
    public String delete(String userID, String docID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String status="";
	OrdinaryDocument result = new OrdinaryDocument(forcedRetrieve(docID)); 
	if (result.isDeleted())
	    return "already deleted";
	String ctrlID = result.getCtrlID();
	if (ctrlID.equals(""))
	    return "defunct document";
	CtrlDocument ctrl =  new CtrlDocument(forcedRetrieve(ctrlID));
	String authID = result.getAuthID();
	authID = authID.substring(5, authID.length());
	if(ctrl.permission(userID, "delete", 
			   result.getAuthID(), result.getCreationDate()))
        {
	  if (docsCache.containsKey(docID))
	    docsCache.remove(docID);
	  ObjectBasedClient obc = newOBC();
	  obc.putObject("delete "+docID);
	  status = (String)obc.getObject();
	  deleteOBC(obc);
	}
	else
	    status = "forbidden";
	return status;
    }

    /** [docID]¸ߤ뤫ݤ֤*/
    public Boolean exists(String docID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	if(docsCache.containsKey(docID))
	    return new Boolean(true);
	OrdinaryDocument d = new OrdinaryDocument(forcedRetrieve(docID));
	if(d.getRoot() == null)
	    return new Boolean(false);
	if(d.isDeleted())
	    return new Boolean(true);
	else
	  {
	      String ctrlID = d.getCtrlID();
	      if (ctrlID.equals("forbidden"))
		return new Boolean(false);
	      TXDocument t = forcedRetrieve(ctrlID);
	      if (t.getDocumentElement() == null)
		  return new Boolean(false);
	      return new Boolean(true);
	  }
    }

    public String showAnnounce(String userID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	AuthDocument auth = 
	  new AuthDocument(forcedRetrieve("auth:"+userID));
	auth.setMessage("");
	String result = auth.getMessage();

	String authID = auth.getID();
        ObjectBasedClient obc = newOBC();
	obc.putObject("put "+authID);
	if (((String)obc.getObject()).equals("ack"))
	{
	    TXDocument authD = auth.getTXDocument();
	    obc.putObject((Object)authD);
	    docsCache.put(authID, authD.clone());
	    authD = null; authID = null;
	}
	obc.getObject();
        deleteOBC(obc);
	return result;
    }

    public String chtext(String userID, String docID, TXElement t)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	if (exists(docID).booleanValue())
	    {
		TXDocument d = forcedRetrieve(docID);
		OrdinaryDocument o = new OrdinaryDocument(d);
		if (!o.getAuthID().equals(authID) 
		    && !o.getID().equals(authID))
		    return ("not the owner.");
		o.getRoot().replaceChild(t, o.getText());
		String result = null;
		result = forcedStore(docID, d);
		return result;
	    }
	else
	    return ("not exists.");
    }
  
    public String chctrl(String userID, String docID, String ctrlID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	if (exists(docID).booleanValue()&&
	    pot.util.Util.getTypeName(ctrlID).equals("ctrl"))
	    {
		TXDocument d = forcedRetrieve(docID);
		OrdinaryDocument o = new OrdinaryDocument(d);
		if (!o.getAuthID().equals(authID))
		    return ("not the owner.");
		o.setLinkID("ctrl", ctrlID);
		return forcedStore(docID, d);
	    }
	else
	    return ("not exists.");
    }

    /** ʸ[docID]νͭ[newOwner]˾롣ȤϤ[newOwner]
      getown()ԤʤȡͭžλʤȤա */
    public String chown(String userID, String newOwner, 
			String docID, String limit)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	String status="";
	AuthDocument nOD = null;
	OrdinaryDocument o = new OrdinaryDocument(forcedRetrieve(docID)); 
	if (o.isDeleted())
	    return "deleted";
	String authID_o = o.getAuthID();
	if (!authID.equals(authID_o))
	    return "not the owner.";
	if (exists(newOwner).booleanValue())
	    nOD = new AuthDocument(forcedRetrieve(newOwner));
	else 
	    return "no such user "+newOwner+".";
	if (limit.equals(""))
	    limit = (String)getProperty("DefaultLimit");
	if (limit.startsWith("A"))
	    {
		ISODate date = new ISODate();
		date.addOffset(limit);
		limit = date.toString();
	    }
	TXElement an = nOD.getAnnounce();
	TXElement[] offers = an.searchChildrenAll("offer");
	boolean x = false;
	for(int i=0; i<offers.length; i++)
	    if (docID.equals(offers[i].getAttribute("id")))
		x = true;
	if (x)
	    return "already offered.";
	TXElement offer = pot.util.Util.preparedTXElement("offer");
	offer.setAttribute("type", "chown");
	offer.setAttribute("id", docID);
	offer.setAttribute("limit", limit); //л
	nOD.getAnnounce().appendChild(offer);
	status = forcedStore(newOwner, nOD.getTXDocument());
	return status;
    }
  
    public String getown(String userID, String docID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	AuthDocument authD = new AuthDocument(forcedRetrieve(authID));
	TXElement an = authD.getAnnounce();
	TXElement[] offers = an.searchChildrenAll("offer");
	TXElement offerE = null;
	for(int i=0; i<offers.length; i++)
	    if (docID.equals(offers[i].getAttribute("id")))
		offerE = offers[i];
	if (offerE == null)
	    return "no such offer.";
	ISODate date = new ISODate();
	if (date.toString().compareTo(offerE.getAttribute("limit")) > 0)
	    return "out of limit.";
	an.removeChild(offerE);
	forcedStore(authID, authD.getTXDocument());
	OrdinaryDocument o = new OrdinaryDocument
	    (forcedRetrieve(docID));
	o.setLinkID("auth", authID);
	return forcedStore(docID, o.getTXDocument());
    }
    
    public String denyown(String userID, String docID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	System.out.println(authID+" + "+docID);
	ISODate date = new ISODate();
	AuthDocument authD = new AuthDocument(forcedRetrieve(authID));
	TXElement an = authD.getAnnounce();
	TXElement[] offers = an.searchChildrenAll("offer");
	TXElement offerE;
	for(int i=0; i<offers.length; i++)
	    if (docID.equals(offers[i].getAttribute("id")))
	    {
		offerE = offers[i];
		if (date.toString().
		    compareTo(offerE.getAttribute("limit")) > 0)
		    return "out of limit.";
		if (docID.equals("all") || 
		    offerE.getAttribute("id").equals(docID))
		    an.removeChild(offerE);
	    }
	return forcedStore(authID, authD.getTXDocument());
    }


    /** ʸ[victim]äȤ롣*/
    public String rmauth(String userID, String victim, String limit)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	String status="";
	AuthDocument o = new AuthDocument(forcedRetrieve("auth:"+victim)); 
	if (o.isDeleted())
	    return "deleted";
	String authID_o = o.getAuthID();
	if (!authID.equals(authID_o))
	    return "not the owner.";
	if (limit.equals(""))
	    limit = (String)getProperty("DefaultLimit");
	if (limit.startsWith("A"))
	    {
		ISODate date = new ISODate();
		date.addOffset(limit);
		limit = date.toString();
	    }
	TXElement an = o.getAnnounce();
	TXElement[] offers = an.searchChildrenAll("offer");
	boolean x = false;
	for(int i=0; i<offers.length; i++)
	    if ("rmauth".equals(offers[i].getAttribute("type")))
		x = true;
	if (x)
	    return "already offered.";
	TXElement offer = pot.util.Util.preparedTXElement("offer");
	offer.setAttribute("type", "rmauth");
	offer.setAttribute("limit", limit); //л
	o.getAnnounce().appendChild(offer);
	status = forcedStore(victim, o.getTXDocument());
	return status;
    }
  
    public String getrmauth(String userID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	AuthDocument authD = new AuthDocument(forcedRetrieve(authID));
	TXElement an = authD.getAnnounce();
	TXElement[] offers = an.searchChildrenAll("offer");
	TXElement offerE = null;
	for(int i=0; i<offers.length; i++)
	    if ("rmauth".equals(offers[i].getAttribute("type")))
		offerE = offers[i];
	if (offerE == null)
	    return "no such offer.";
	ISODate date = new ISODate();
	if (date.toString().compareTo(offerE.getAttribute("limit")) > 0)
	    return "out of limit.";
	an.removeChild(offerE);
	return delete(authD.getAuthID(), authID);
    }
    
    public String denyrmauth(String userID)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	String authID = "auth:"+userID;
	ISODate date = new ISODate();
	AuthDocument authD = new AuthDocument(forcedRetrieve(authID));
	TXElement an = authD.getAnnounce();
	TXElement[] offers = an.searchChildrenAll("offer");
	TXElement offerE;
	for(int i=0; i<offers.length; i++)
	    if ("rmauth".equals(offers[i].getAttribute("type")))
	    {
		offerE = offers[i];
		if (date.toString().
		    compareTo(offerE.getAttribute("limit")) > 0)
		    return "out of limit.";
		an.removeChild(offerE);
	    }
	return forcedStore(authID, authD.getTXDocument());
    }

    public boolean verifyLocalRoot(String userID)
    {
	return (userID.equals(getProperty("LocalRoot")));
    }

    public boolean verifyLogin(String userID, String passwd)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
      String authID = "auth:"+userID;
      if (exists(authID).booleanValue())
      {
	AuthDocument auth = 
	  new AuthDocument(forcedRetrieve(authID));
	return auth.verifyLogin(passwd);
      }
      else
	return false;
    }
}

