package pot.phys;

import pot.serverskeleton.*;
import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;

public class StorageChildServer extends ObjectBasedChildServer
{
    StorageParentServer pt;

    public StorageChildServer(GenericParentServer gps, Socket s)
    {
	super(gps, s);
	pt = (StorageParentServer)parent;
    }

    public void handle(String command)
	throws IOException, ClassNotFoundException, DisconnectionException
    {
	StringTokenizer st = new StringTokenizer(command, " \t");
	if (st.hasMoreTokens())
	{
		String cmd = st.nextToken();
		if (cmd.equals("get") && st.hasMoreTokens())
		{
		    TXDocument d = pt.retrieve(st.nextToken());
		    putObject(d);
		}
		else if (cmd.equals("ls") && st.hasMoreTokens())
		{
		    TXDocument d = pt.ls(st.nextToken());
		    putObject(d);
		}
		else if (cmd.equals("exists") && st.hasMoreTokens())
		{
		    Boolean b = new Boolean(pt.exists(st.nextToken()));
		    putObject(b);
		}
		else if (cmd.equals("put") && st.hasMoreTokens())
		{
		    putObject("ack"); //Ʊ뤿ɬ
		    String status = pt.store(st.nextToken(), 
				      (TXDocument)getObject());
		    printLog(status);
		    putObject(status);
		}
	    }
    }
    
    public void run()
    {
	try
	{
	    openObjectStream();
	    handle((String)getObject());
        }
	catch(ClassNotFoundException e)
	{
	    printLog(e);
	}
	catch(IOException e)
	{
	    printLog(e);
	}
	catch(DisconnectionException e)
	{
	    printLog(e);
	}
	finally
	{
	    try
	    {
		disconnect();
	    }
	    catch(DisconnectionException e)
	    {
		printLog(e);
	    }
	}
    }
}

