package pot.phys;

import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import pot.serverskeleton.*;

public class StorageParentServer extends SocketParentServer
{
    StorageReadClient src;
    StorageWriteClient swc;
    String[] basePath;
  
    public StorageParentServer(String confPath)
	throws ConstructionFailureException
    {
        super(confPath);
	setBasePaths();
    }

    void setBasePaths()
    {
	basePath = new String[2];
	basePath[0] = (String)getProperty("BasePath")
	  +"/"+pot.util.Util.getShortHostName()+"1";
    }

    protected boolean verifyRemoteHost(Socket socket)
    {
	return (socket.getInetAddress().equals(socket.getLocalAddress()));
    }

    public GenericChildServer newChild(Socket ss) throws Exception
    {
        return new StorageChildServer(this, ss);
    }

    public void getStorageReadClient(String path, int n) throws IOException
    {
	src = new StorageReadClient
	  (this, basePath[n], path);
    }

    public void getStorageWriteClient(String path, int n) throws IOException
    {
	swc = new StorageWriteClient
	  (this, basePath[n], path);
    }

    public TXDocument retrieve(String path)
	 throws IOException
    {
	getStorageReadClient(pot.util.Util.colon2SlashColon(path), 0);
	TXDocument d = src.getCopy();
	src = null;
	return d;
    }

    public TXDocument ls(String path) throws IOException
    {
	getStorageReadClient(pot.util.Util.colon2SlashColon(path), 0);
	TXDocument d = src.getLs();
	src = null;
	return d;
    }

    public boolean exists(String path) throws IOException
    //Ψΰ
    {
	TXDocument d = retrieve(path);
	return (d.getDocumentElement() != null);
    }

    public String store(String path, TXDocument d)
	 throws IOException
    {
	getStorageWriteClient(path, 0);
	String status = swc.putCopy(d);
	swc = null;
	return status;
    }
}

