package pot.phys;

import pot.serverskeleton.*;
import pot.util.*;
import java.util.*;
import java.io.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;

/** Υե뤫XMLեФTXDocumentˤϤ */
public class StorageReadClient 
extends FileClient implements StorageClient
{
    CatalogParser p;
    String basePath;

    public StorageReadClient(GenericParentServer _parent, 
			     String _basePath, String path)
	 throws IOException
    {
	super(_parent, path);
	basePath = _basePath;
	p = new CatalogParser
	     ("phys", (String)parent.getProperty("URLCatalogPath"));
    }

    public synchronized TXDocument getCopy() throws IOException
    {
	try
	{
	    return p.readStream(new BufferedReader(new FileReader
			(basePath+"/"+filePath)));
	}
	catch(FileNotFoundException e)
	{
	    return pot.util.Util.nullTXDocument();
	}
    }
    
    public synchronized TXDocument getLs() throws IOException
    {
	try
	{
	    if (filePath.endsWith(":"))
	    {
		return pot.util.Util.nullTXDocument();
	    }
	    else
	    {
		TXDocument result = pot.util.Util.preparedTXDocument("ls");
		TXElement root = (TXElement)result.getDocumentElement();
		root.setAttribute("path", 
				  pot.util.Util.omitSlashes(filePath));
		root.setAttribute("date", new ISODate().toString());
		TXElement item;
		java.io.File f = new java.io.File(basePath+"/"+filePath+":");
		String[] files = f.list();
		for(int i=0; i<files.length; i++)
		{
		    item = pot.util.Util.preparedTXElement("item");
		    item.setAttribute("id", pot.util.Util.omitSlashes
				      (filePath+":"+files[i]));
		    root.appendChild(item);
		}
		return result;
	    }
	}
	catch(NullPointerException e)
	{
	    System.err.println(e);
	    return pot.util.Util.nullTXDocument();
	}
    }
    
    public void run(){}
}

