package pot.serverskeleton;

import java.io.*;
import java.net.*;
import java.util.*;

public class FileChildServer extends TextBasedChildServer
{
    FileReadClient frc;
    FileWriteClient fwc;

    public FileChildServer(GenericParentServer gps, Socket s) 
	 throws IOException
    {
        super(gps, s);
    }

    public void getFileReadClient(String path) throws IOException
    {
	frc = new FileReadClient(parent, path);
	frc.openStream();
    }

    public void leaveFileReadClient() throws IOException
    {
	frc.disconnect();
    }

    public String[] getFileLines() throws IOException
    {
        return frc.getFile();
    }

    public void getFileWriteClient(String path) throws IOException
    {
	fwc = new FileWriteClient(parent, path);
	fwc.openStream();
    }

    public void leaveFileWriteClient() throws IOException
    {
	fwc.disconnect();
    }

    public void putFileLines(String[] lines) throws IOException
    {
        fwc.putFile(lines);
    }

    public void run()
    {
	String command, line;
	StringTokenizer st;
	String[] lines;
	int size;

	try
	{
	    openStream();
	    st = new StringTokenizer(getLine(), " ");
	    if (st.hasMoreTokens())
	    {
		command = st.nextToken();
		if (command.equals("get") && st.hasMoreTokens())
		{
		    getFileReadClient(st.nextToken());
		    lines = getFileLines();
		    leaveFileReadClient();
		    size = lines.length;
		    for(int i=0; i<size; i++)
			putLine(lines[i]);
		}
		else if (command.equals("put") && st.hasMoreTokens())
		{
		    Vector v = new Vector();
		    
		    getFileWriteClient(st.nextToken());
		    while(true)
		    {
			line = getLine();
			if (line.equals(".")) break;
			v.addElement(line);
		    }
		    size = v.size();
		    lines = new String[size];
		    for(int i=0; i<size; i++)
			lines[i] = (String)v.elementAt(i);
		    putFileLines(lines);
		    leaveFileWriteClient();
		}
	    }
        }
	catch(IOException e)
	{
	    printLog(e);
	}
	finally
	{
	    try
	    {
		disconnect();
	    }
	    catch(DisconnectionException e)
	    {
		printLog(e);
	    }
	}
    }
}

