package pot.serverskeleton;

public abstract class GenericChildServer implements Runnable
{
    protected GenericParentServer parent = null;
    protected Thread th = null;

    public GenericChildServer(GenericParentServer gps)
    {
	setParent(gps);
	startThread();
    }

    public void startThread()
    {
	if (th == null)
	{
	    th = new Thread(parent.getThreadGroup(), this);
	    th.start();
	}
    }

    public void stopThread()
    {
      th.stop();
    }

    protected void printLog(Object line)
    {
	parent.printLog(line);
    }

    public void setParent(GenericParentServer gpf)
    {
	if (parent == null)
	    parent = gpf;
    }

    public GenericParentServer getParent()
    {
	return parent;
    }

    public void disconnect() throws DisconnectionException
    {
	parent.dispose(this);
    }
  
    public abstract void run();
}

