package pot.serverskeleton;

import java.io.*;
import java.util.*;

/**  
  ƳؤΥФΥȥ󥯥饹
  åȴطƤʤΡ
  Clientǽϻҥ饹BuiltInSocketClientȤƼ¸
  */
public abstract class GenericParentServer implements Runnable
{
    final int maximumChildren = 16;
    int connections = 0; //߷פ³
    protected PrintWriter log;
    Vector childrenList;
    Hashtable propertyList;
    protected ThreadGroup thg;
    protected Thread th = null;
    
    /** 󥹥ȥ饯 */
    public GenericParentServer(String confPath) 
	 throws ConstructionFailureException
    {
	childrenList = new Vector();
	thg = new ThreadGroup(this.toString());
        readConf(confPath);
        setProperties();
	startThread();
    }

    /** եɤ߹ */
    protected void readConf(String confPath)
	 throws ConstructionFailureException
    {
	BufferedReader conf;
	StringTokenizer st;
	String line, property;

	propertyList = new Hashtable();

	try
	{
	    conf = new BufferedReader(new FileReader(confPath));
	    while ((line = conf.readLine()) != null)
	    {
		st = new StringTokenizer(line, "\t ");
		if (st.countTokens() == 2)
		{
		    property = st.nextToken();
		    if (!property.equals("#"))
		    {
			propertyList.put(property, st.nextToken());
		    }
		}
		else if (st.countTokens()>2)
		{
		    property = st.nextToken();
		    if (st.nextToken().equals("VECTOR"))
		    {
			Vector v = new Vector();
			while(st.hasMoreTokens())
			    v.addElement(st.nextToken());
			propertyList.put(property, v);
		    }
		}
	    }
	    conf.close();
	}
	catch(IOException e)
	{
	    throw new ConstructionFailureException();
	}
    }

    protected void setProperties() throws ConstructionFailureException
    {
	try
	{
	    setLogWriter();
	}
	catch(IOException e)
	{
	    throw new ConstructionFailureException();
	}
    }

    protected String getLogFileName()
    {
	return (String)propertyList.get("LogFilePath")+
	  "."+pot.util.Util.getShortHostName();
    }

    public Writer getLogWriter()
    {
	return log;
    }
    
    protected void setLogWriter() throws IOException
    {
	if (getLogFileName().equals("stdout"))
	    log = new PrintWriter(System.out);
	else
	    log = new PrintWriter(new FileWriter(getLogFileName()));
    }    

    public ThreadGroup getThreadGroup()
    {
	return thg;
    }

    public void startThread()
    {
	if (th == null)
	{
	    th = new Thread(thg, this);
	    th.start();
	    printLog("# "+this+" started.");
	}
    }
    
    public void stopThread()
    {
	th.stop(); 
    }
    
    /** 1Խ */
    protected void printLog(Object line)
    {
	log.println(line); log.flush();
    }

    public synchronized void destroy()
    {
	Enumeration childrenEnum = childrenList.elements();
	while(childrenEnum.hasMoreElements())
	{
	    dispose((GenericChildServer)childrenEnum.nextElement());
	}
	//printLog("# "+this+" terminated.");
	log.close();
	moveLog();
    }

    public synchronized void dispose(GenericChildServer gs)
    {
	if (childrenList.contains(gs))
	{
	    childrenList.removeElement(gs);
	    //printLog("Now "+getChildrenNumber()+" child(ren).");
	    gs.stopThread();
	}
    }

    //public abstract GenericChildServer newChild() throws Exception;

    protected synchronized void addChild(GenericChildServer gcs)
    {
	childrenList.addElement(gcs);
	//printLog("Now "+getChildrenNumber()+" child(ren).");
	connections++;
    }
    
    protected synchronized void removeChild(GenericChildServer s)
    {
	childrenList.removeElement(s);
    }
    
    public Object getProperty(String propName)
    {
	return propertyList.get(propName);
    }
    
    public int getChildrenNumber()
    {
	return childrenList.size();
    }

    public int getConnectionsNumber()
    {
	return connections;
    }

    public abstract void run();
}

