package pot.serverskeleton;

import java.io.*;
import java.util.*;

/**  
  ParentServer򥳥ȥ뤹롣
  */
public abstract class GrandParentServer
{
    protected BufferedReader ti;
    protected PrintWriter to;
    protected String prompt = "> ";

    protected GrandParentServer()
    {
	setTerminal();
	run();
    }
    
    public void setTerminal()
    {
        ti = new BufferedReader(new InputStreamReader(System.in));
        to = new PrintWriter(System.out, true);
    }   

    public String getTerminalLine() throws IOException
    {
	return ti.readLine();
    }

    public void putTerminalLine(String line)
    {
        to.println(line);
    }

    public void putTerminal(String line)
    {
        to.print(line); to.flush();
    }
    
    public abstract void init() 
	throws ConstructionFailureException, IOException;
    public abstract void go();
    public abstract void stop();
    public abstract void quit();
    
    public void handle(String reply)
    {
    }

    public void run()
    {
        String reply;
	try
	{
	    setTerminal();
	    init();
	    while(true)
	    {       
		putTerminal(prompt);
		reply = getTerminalLine();
		if (reply.equals("go"))
		    go();
		else if (reply.equals("stop"))
		    stop();
		else if (reply.equals("quit"))
		    quit();
		else
		    handle(reply);
	    }
	}
        catch(IOException e)
        {
            System.err.println(e);
        }
        catch(ConstructionFailureException e)
        {
            System.err.println(e);
        }
    }
}

