package pot.serverskeleton;

import java.io.*;
import java.net.*;

public class ObjectBasedChildServer extends SocketChildServer
  implements ObjectBasedInterface
{
    ObjectInputStream ois;
    ObjectOutputStream oos;

    public ObjectBasedChildServer(GenericParentServer gps, Socket s)
    {
	super(gps, s);
    }
  
    public void openObjectStream() throws IOException, ClassNotFoundException
    {
	ois = new ObjectInputStream(ss.getInputStream());
	if (!ois.readObject().equals("helo"))
	    throw new IOException();
	oos = new ObjectOutputStream(ss.getOutputStream());
	oos.writeObject("helo"); oos.flush();
    }

    /** 饤Ȥ1ĤΥ֥Ȥ */
    public Object getObject() throws IOException, ClassNotFoundException
    {
	return ois.readObject();
    }

    /** 饤Ȥ1ĤΥ֥Ȥ */
    public void putObject(Object o) throws IOException
    {
	    oos.writeObject(o); oos.flush();
    }

    public void disconnect() throws DisconnectionException
    {
	try
	{
	    putObject("bye");
	    ss.close();
	}
	catch(IOException e)
	{
	    throw new DisconnectionException();
	}
	super.disconnect();
    }

    //ϰ㡣
    public void handle(Object command)
	 throws IOException, ClassNotFoundException, DisconnectionException
    {
	putObject(command);
    }
    
    //ϰ㡣
    public void run()
    {
	Object command;

	try
	{
	    openObjectStream();
	    while(true)
	    {
		command = getObject();
		if (command == null || 
		    (command.getClass() == String.class &&
		     ((String)command).equals("bye")))
		    disconnect();
		else
		    handle(command);
	    }
	}
	catch (IOException e)
	{
	    printLog(e);
	}
	catch (ClassNotFoundException e)
	{
	    printLog(e);
	}
	catch (DisconnectionException e)
	{
	    printLog(e);
	}
    }
}

