package pot.serverskeleton;

import java.io.*;

public class ObjectBasedClient extends SocketClient 
  implements ObjectBasedInterface
{
    ObjectInputStream ois; 
    ObjectOutputStream oos;
    
    public ObjectBasedClient(GenericParentServer _parent, String _hostName,
			     int _portNumber) throws IOException
    {
        super(_parent, _hostName, _portNumber);	
    }

    public synchronized void openObjectStream() 
	 throws IOException, ClassNotFoundException
    {
	oos = new ObjectOutputStream(clientSocket.getOutputStream());
	oos.writeObject("helo"); oos.flush();
	ois = new ObjectInputStream(clientSocket.getInputStream());
	if (!ois.readObject().equals("helo"))
	    throw new IOException();
    }

    /** Ф饪֥Ȥ1ɤ߹ */
    public Object getObject() throws IOException, ClassNotFoundException
    {
	return ois.readObject();
    }

    /** Ф1ĤΥ֥Ȥ */
    public void putObject(Object o) throws IOException
    {
	oos.writeObject(o); oos.flush();
    }

    public void disconnect() throws DisconnectionException
    {
	try
	{
	    putObject("bye");
	    super.disconnect();
	}
	catch(IOException e)
	{
	    throw new DisconnectionException();
	}
    }

    public void handle(Object o)
    {
    }

    //dummy for linkage.
    public void run()
    {
    }
}

