package pot.serverskeleton;

import java.io.*;
import java.net.*;

public abstract class SocketChildServer extends GenericChildServer
{
    protected Socket ss = null;

    public SocketChildServer(GenericParentServer gps, Socket s)
    {
	super(gps);
	ss = s;
    }

    public int getSocketNumber()
    {
	return ss.getPort();
    }

    public void setParent(GenericParentServer gps)
    {
	if (parent == null && ss == null)
	    parent = gps;
    }

    public void disconnect() throws DisconnectionException
    {
	try
	{
	    ss.close();
	}
	catch(IOException e)
	{
	    throw new DisconnectionException();
	}
	super.disconnect();
    }

    public abstract void run();
}

