package pot.serverskeleton;

import java.io.*;
import java.net.*;

/**
  GenericParentServer˥åȴϢμäΡ
  TCP/IPˤƥȵڤJava Class Object̿򥵥ݡȤ롣
*/
public abstract class SocketParentServer extends GenericParentServer
{
    protected int portNumber;
    protected ServerSocket serverParentSocket = null;

    public SocketParentServer(String confPath)
	 throws ConstructionFailureException
    {
	super(confPath);
	//startThread();
    }

    protected void setProperties() throws ConstructionFailureException
    {
	super.setProperties();
	portNumber = Integer.parseInt
	    ((String)propertyList.get("ListeningPortNumber"));
    }

    public int getPortNumber()
    {
	return portNumber;
    }

    protected boolean verifyRemoteHost(Socket socket)
    {
      return true;
    }

    //ȴŪˤϡInitServerSocketͿ褦˲¤
    protected synchronized void makeServerSocket() throws IOException
    {
	serverParentSocket = new ServerSocket(portNumber);
	printLog("#"+getClass()+" started on port #"+
		 serverParentSocket.getLocalPort()+".");
	printLog(" SoTimeout is "+serverParentSocket.getSoTimeout()+".");
    }
    
    protected void setTimeout(Socket s)
    {
	//s.setSoTimeout(20*1000);
    }

    public Socket accept() throws IOException
    {
      Socket s = serverParentSocket.accept();
      setTimeout(s);
      if (verifyRemoteHost(s)) return s;
      else 
	{
	  s.close();
	  return null;
	}
    }

    public synchronized void dispose(GenericChildServer gs)
    {
      String gsPort = new Integer(((SocketChildServer)gs).
				  getSocketNumber()).toString();
      //printLog("Connection Terminated on port #"+gsPort+".");
      super.dispose(gs);
    }
    
    public abstract GenericChildServer newChild(Socket ss) throws Exception;
    
    protected synchronized void addChild(Socket ss) throws Exception
    {
	GenericChildServer gcs;

	//printLog("Connection Established on port #"+ss.getPort()+".");
	gcs = newChild(ss);
	addChild(gcs);
    }

    public void run()
    {
	Socket s;
	try{
	    //th.sleep(500);//ֺ
	    makeServerSocket();
	    while(true)
	      {
		  try{
		      s = this.accept();
		      if (s != null)
			  addChild(s);
		  }catch(InterruptedIOException e)
		      {printLog(e);}
	      }
	}
	catch(Throwable e)
	{
	    printLog(e);
	}	
    }
}

