package pot.serverskeleton;

import java.io.*;
import java.net.*;
import java.util.*;
import pot.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;

public abstract class T2XPipe extends TextBasedChildServer
  implements PipeInterface
{
    protected ObjectBasedClient obc;
    protected String remoteHostName;
    protected int remotePortNumber;

    public T2XPipe(GenericParentServer gps, Socket s, String _hostName, 
		   Integer _portNumber) throws IOException
    {
        super(gps, s);
	remoteHostName = _hostName;
	remotePortNumber = _portNumber.intValue();
	setPrompt("T2X> ");
    }

    public void disconnect() throws DisconnectionException
    {
	super.disconnect();
    }

    public void newOBC() throws IOException, ClassNotFoundException
    {
	obc = new ObjectBasedClient(parent, remoteHostName, remotePortNumber);
	//obc.startThread();
	obc.openObjectStream();
    }

    public void deleteOBC() throws DisconnectionException
    {
	obc.disconnect();
	obc = null;
    }
    
    public TXDocument getXMLFile() throws IOException
    {
	Source s = new Source(br);
        CatalogParser p = new CatalogParser
             ("dist", (String)parent.getProperty("URLCatalogPath"));
	TXDocument d = p.readStream(s);
	//d.printWithFormat(parent.getLogWriter());
	//p.closeInputStream(s);
	return d;
    }
    
    public TXDocument getXMLFile2(String path) throws IOException
    {
	//resultdocumentĤƤ

	String text = "\n", line; //餤ޤפʤ?
	TXDocument result = pot.util.Util.preparedTXDocument("copy");

	while(!(line = br.readLine()).equals("."))
	    text += (line+"\n");
	result.getDocumentElement().appendChild(result.createTextNode(text));
	return result;
    }

    public void putXMLFile(TXDocument txd) throws IOException
    {
	txd.printWithFormat(pw);
	pw.flush();
	//pw.close();
    }

    public abstract void handle(String command)
        throws IOException,  DisconnectionException;

    public void run()
    {
	try{
	    openStream();
	    while(true)
	    {
		putPrompt();
		handle(getLine());
	    }
	}catch(IOException e){
	    printLog(e);
	}catch(DisconnectionException e){
	    printLog(e);
	}
	finally{
	    try{
		disconnect();
	    }catch(DisconnectionException e){
		printLog(e);
	    }
	}
    }
}

