package pot.serverskeleton;

import java.io.*;

public class TextBasedClient extends SocketClient
  implements TextBasedInterface
{
    protected BufferedReader br;
    protected PrintWriter pw;
    String prompt = "";

    public TextBasedClient(GenericParentServer _parent, String _hostName,
			   int _portNumber) throws IOException
    {
	super(_parent, _hostName, _portNumber);
    }

    public void openStream() throws IOException
    {
            br = new BufferedReader
                (new InputStreamReader(clientSocket.getInputStream()));
            pw = new PrintWriter(clientSocket.getOutputStream());
    }	

    public void setPrompt(String s)
    {
        prompt = s;
    }

    public String getPrompt()
    {
        return prompt;
    }

    public Reader getReader()
    {
	return br;
    }

    public Writer getWriter()
    {
	return pw;
    }
    
    public synchronized String getLine() throws IOException
    {
	return br.readLine();
    }

    public synchronized void putLine(String line)
    {
	pw.println(line); pw.flush();
    }
    
    public synchronized void putString(String line)
    {
	pw.print(line); pw.flush();
    }
    
    public synchronized void putEOF()
    {
	pw.write(-1);
    }

    public void disconnect() throws DisconnectionException
    {
	putLine("bye");
	super.disconnect();
    }

    public synchronized void handle(String reply)
    {
    }
    
    public void run()
    {
    }
}

