package pot.util;

import java.io.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;

public class CatalogParser extends Parser
{
    class Terminator implements ElementHandler
    {
	public TXElement handleElement(TXElement el)
	{
	    CatalogParser.this.stop();
	    return el;
	}
    }

    public CatalogParser(String filePath, String catalogPath)
	 throws IOException
    {
	super(filePath);

	InputStreamReader catalog = new InputStreamReader
	    (new FileInputStream(catalogPath));
	loadCatalog(catalog);
	setPreserveSpace(false);
	addElementHandler(new Terminator(), "doc");
    }
}

