package pot.util;

import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;

/** static method */
public class Util
{
    public static TXDocument nullTXDocument()
    {
	TXDocument result = new TXDocument();
        result.setVersion("1.0");
	return result;
        //String encode = "ISO-8859-1";
        //String mEncode = MIME2Java.convert(encode);
        //result.setEncoding(encode);
    }

    public static TXDocument preparedTXDocument(String rootname)
    {
	TXDocument result = nullTXDocument();
	result.appendChild((TXElement)result.createElement(rootname));
	return result;
    }

    public static TXElement preparedTXElement(String tagname)
    {
	TXDocument d = nullTXDocument();
	return (TXElement)d.createElement(tagname);
    }

    public static TXElement preparedTXElement(String tagname, String txt)
    {
	TXElement result;
	TXDocument d = nullTXDocument();
	result = (TXElement)d.createElement(tagname);
	result.appendChild(d.createTextNode(txt));
	return result;
    }

    public static String colon2SlashColon(String id)
    {
	StringTokenizer st = new StringTokenizer(id, ":");
	StringBuffer r = new StringBuffer("");
	while (st.hasMoreTokens())
	{
	    r.append(":/"+st.nextToken());
	}
	String result = r.toString();
	return result.substring(2, result.length());
    }

    public static String omitSlashes(String id)
    {
	StringTokenizer st = new StringTokenizer(id, "/");
	StringBuffer r = new StringBuffer("");
	while (st.hasMoreTokens())
	{
	    r.append(st.nextToken());
	}
	return r.toString();
    }

    public static String getDocType(TXDocument d)
    {
	TXAttribute a;
	TXElement r =
	    (TXElement)d.getDocumentElement();
	if (r != null)
	    a = (TXAttribute)r.getAttributeNode("id");
	else 
	    return null;
	if (a != null)
	    return getTypeName(a.getValue());
	else 
	    return null;
    }

    public static String getTypeName(String id)
    {
	String result = "";
	try{result = id.substring(0,4);}
	catch(StringIndexOutOfBoundsException e){};
	return result;
    }

    public static String[] splitIDs(String ids)
    {
	StringTokenizer st = new StringTokenizer(ids, ",");
	int n = st.countTokens();
	String[] result = new String[n];

	for(int i=0; i<n; i++)
	    result[i]= st.nextToken();
	return result;
    }

    public static boolean isAdequateSchedule(TXElement t)
    {
	return (t.getTagName().equals("text"));
    }

    public static String getLongHostName()
    {
      String result;
      try{
	return InetAddress.getLocalHost().getHostName();
      }catch(UnknownHostException e){
       return ".";
      }
    }

    public static String getShortHostName()
    {
      StringTokenizer st = new StringTokenizer(getLongHostName(), ".");
      return st.nextToken();
    }
}
